import{s as Be,f as j,n as Fe,o as We}from"../chunks/scheduler.37c15a92.js";import{S as Oe,i as Ke,g as l,s as i,r as A,A as De,h as r,f as n,c as s,j as ze,u as J,x as o,k as g,y as Ne,a,v as z,d as B,t as F,w as W}from"../chunks/index.7cb9c9b8.js";import{H as O}from"../chunks/Heading.d3928e2a.js";function Qe(_e){let u,K,q,D,m,N,c,Te,Q,p,$e='SnowballTarget is an environment we created at Hugging Face using assets from <a href="https://kaylousberg.com/" rel="nofollow">Kay Lousberg</a>. We have an optional section at the end of this Unit <strong>if you want to learn to use Unity and create your environments</strong>.',V,f,X,h,ye="The first agent you’re going to train is called Julien the bear 🐻. Julien is trained <strong>to hit targets with snowballs</strong>.",Y,v,xe="The Goal in this environment is that Julien <strong>hits as many targets as possible in the limited time</strong> (1000 timesteps). It will need <strong>to place itself correctly in relation to the target and shoot</strong>to do that.",Z,d,Me="In addition, to avoid “snowball spamming” (aka shooting a snowball every timestep), <strong>Julien has a “cool off” system</strong> (it needs to wait 0.5 seconds after a shoot to be able to shoot again).",ee,w,Ce='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/cooloffsystem.gif" alt="Cool Off System"/> <figcaption>The agent needs to wait 0.5s before being able to shoot a snowball again</figcaption>',te,b,ne,_,He="The reward function is simple. <strong>The environment gives a +1 reward every time the agent’s snowball hits a target</strong>. Because the agent’s Goal is to maximize the expected cumulative reward, <strong>it will try to hit as many targets as possible</strong>.",ae,T,Le,ie,$,Pe=`We could have a more complex reward function (with a penalty to push the agent to go faster, for example). But when you design an environment, you need to avoid the <em>reward engineering problem</em>, which is having a too complex reward function to force your agent to behave as you want it to do.
Why? Because by doing that, <strong>you might miss interesting strategies that the agent will find with a simpler reward function</strong>.`,se,y,Ie="In terms of code, it looks like this:",le,x,Ge,re,M,oe,C,Se="Regarding observations, we don’t use normal vision (frame), but <strong>we use raycasts</strong>.",ge,H,ke="Think of raycasts as lasers that will detect if they pass through an object.",ue,L,Ee='<img src="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit5/raycasts.png" alt="Raycasts"/> <figcaption>Source: <a href="https://github.com/Unity-Technologies/ml-agents">ML-Agents documentation</a></figcaption>',me,P,Re="In this environment, our agent has multiple set of raycasts:",ce,I,je,pe,G,qe="In addition to raycasts, the agent gets a “can I shoot” bool as observation.",fe,S,Ue,he,k,ve,E,Ae="The action space is discrete:",de,R,Je,we,U,be;return m=new O({props:{title:"The SnowballTarget Environment",local:"the-snowballtarget-environment",headingTag:"h1"}}),f=new O({props:{title:"The agent’s Goal",local:"the-agents-goal",headingTag:"h2"}}),b=new O({props:{title:"The reward function and the reward engineering problem",local:"the-reward-function-and-the-reward-engineering-problem",headingTag:"h2"}}),M=new O({props:{title:"The observation space",local:"the-observation-space",headingTag:"h2"}}),k=new O({props:{title:"The action space",local:"the-action-space",headingTag:"h2"}}),{c(){u=l("meta"),K=i(),q=l("p"),D=i(),A(m.$$.fragment),N=i(),c=l("img"),Q=i(),p=l("p"),p.innerHTML=$e,V=i(),A(f.$$.fragment),X=i(),h=l("p"),h.innerHTML=ye,Y=i(),v=l("p"),v.innerHTML=xe,Z=i(),d=l("p"),d.innerHTML=Me,ee=i(),w=l("figure"),w.innerHTML=Ce,te=i(),A(b.$$.fragment),ne=i(),_=l("p"),_.innerHTML=He,ae=i(),T=l("img"),ie=i(),$=l("p"),$.innerHTML=Pe,se=i(),y=l("p"),y.textContent=Ie,le=i(),x=l("img"),re=i(),A(M.$$.fragment),oe=i(),C=l("p"),C.innerHTML=Se,ge=i(),H=l("p"),H.textContent=ke,ue=i(),L=l("figure"),L.innerHTML=Ee,me=i(),P=l("p"),P.textContent=Re,ce=i(),I=l("img"),pe=i(),G=l("p"),G.textContent=qe,fe=i(),S=l("img"),he=i(),A(k.$$.fragment),ve=i(),E=l("p"),E.textContent=Ae,de=i(),R=l("img"),we=i(),U=l("p"),this.h()},l(e){const t=De("svelte-u9bgzb",document.head);u=r(t,"META",{name:!0,content:!0}),t.forEach(n),K=s(e),q=r(e,"P",{}),ze(q).forEach(n),D=s(e),J(m.$$.fragment,e),N=s(e),c=r(e,"IMG",{src:!0,alt:!0}),Q=s(e),p=r(e,"P",{"data-svelte-h":!0}),o(p)!=="svelte-tjcuuk"&&(p.innerHTML=$e),V=s(e),J(f.$$.fragment,e),X=s(e),h=r(e,"P",{"data-svelte-h":!0}),o(h)!=="svelte-1n4q7lh"&&(h.innerHTML=ye),Y=s(e),v=r(e,"P",{"data-svelte-h":!0}),o(v)!=="svelte-1kbt7gr"&&(v.innerHTML=xe),Z=s(e),d=r(e,"P",{"data-svelte-h":!0}),o(d)!=="svelte-dkh5jq"&&(d.innerHTML=Me),ee=s(e),w=r(e,"FIGURE",{"data-svelte-h":!0}),o(w)!=="svelte-1m1t9ww"&&(w.innerHTML=Ce),te=s(e),J(b.$$.fragment,e),ne=s(e),_=r(e,"P",{"data-svelte-h":!0}),o(_)!=="svelte-d7uy51"&&(_.innerHTML=He),ae=s(e),T=r(e,"IMG",{src:!0,alt:!0}),ie=s(e),$=r(e,"P",{"data-svelte-h":!0}),o($)!=="svelte-17at3tr"&&($.innerHTML=Pe),se=s(e),y=r(e,"P",{"data-svelte-h":!0}),o(y)!=="svelte-1sp5sxs"&&(y.textContent=Ie),le=s(e),x=r(e,"IMG",{src:!0,alt:!0}),re=s(e),J(M.$$.fragment,e),oe=s(e),C=r(e,"P",{"data-svelte-h":!0}),o(C)!=="svelte-h5sa4r"&&(C.innerHTML=Se),ge=s(e),H=r(e,"P",{"data-svelte-h":!0}),o(H)!=="svelte-1sy1glw"&&(H.textContent=ke),ue=s(e),L=r(e,"FIGURE",{"data-svelte-h":!0}),o(L)!=="svelte-1ihdfq4"&&(L.innerHTML=Ee),me=s(e),P=r(e,"P",{"data-svelte-h":!0}),o(P)!=="svelte-q67na8"&&(P.textContent=Re),ce=s(e),I=r(e,"IMG",{src:!0,alt:!0}),pe=s(e),G=r(e,"P",{"data-svelte-h":!0}),o(G)!=="svelte-jiha0j"&&(G.textContent=qe),fe=s(e),S=r(e,"IMG",{src:!0,alt:!0}),he=s(e),J(k.$$.fragment,e),ve=s(e),E=r(e,"P",{"data-svelte-h":!0}),o(E)!=="svelte-1dhzfig"&&(E.textContent=Ae),de=s(e),R=r(e,"IMG",{src:!0,alt:!0}),we=s(e),U=r(e,"P",{}),ze(U).forEach(n),this.h()},h(){g(u,"name","hf:doc:metadata"),g(u,"content",Ve),j(c.src,Te="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget.gif")||g(c,"src",Te),g(c,"alt","SnowballTarget"),j(T.src,Le="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget_reward.png")||g(T,"src",Le),g(T,"alt","Reward system"),j(x.src,Ge="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget-reward-code.png")||g(x,"src",Ge),g(x,"alt","Reward"),j(I.src,je="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowball_target_raycasts.png")||g(I,"src",je),g(I,"alt","Raycasts"),j(S.src,Ue="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget-obs-code.png")||g(S,"src",Ue),g(S,"alt","Obs"),j(R.src,Je="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit7/snowballtarget_action_space.png")||g(R,"src",Je),g(R,"alt","Action Space")},m(e,t){Ne(document.head,u),a(e,K,t),a(e,q,t),a(e,D,t),z(m,e,t),a(e,N,t),a(e,c,t),a(e,Q,t),a(e,p,t),a(e,V,t),z(f,e,t),a(e,X,t),a(e,h,t),a(e,Y,t),a(e,v,t),a(e,Z,t),a(e,d,t),a(e,ee,t),a(e,w,t),a(e,te,t),z(b,e,t),a(e,ne,t),a(e,_,t),a(e,ae,t),a(e,T,t),a(e,ie,t),a(e,$,t),a(e,se,t),a(e,y,t),a(e,le,t),a(e,x,t),a(e,re,t),z(M,e,t),a(e,oe,t),a(e,C,t),a(e,ge,t),a(e,H,t),a(e,ue,t),a(e,L,t),a(e,me,t),a(e,P,t),a(e,ce,t),a(e,I,t),a(e,pe,t),a(e,G,t),a(e,fe,t),a(e,S,t),a(e,he,t),z(k,e,t),a(e,ve,t),a(e,E,t),a(e,de,t),a(e,R,t),a(e,we,t),a(e,U,t),be=!0},p:Fe,i(e){be||(B(m.$$.fragment,e),B(f.$$.fragment,e),B(b.$$.fragment,e),B(M.$$.fragment,e),B(k.$$.fragment,e),be=!0)},o(e){F(m.$$.fragment,e),F(f.$$.fragment,e),F(b.$$.fragment,e),F(M.$$.fragment,e),F(k.$$.fragment,e),be=!1},d(e){e&&(n(K),n(q),n(D),n(N),n(c),n(Q),n(p),n(V),n(X),n(h),n(Y),n(v),n(Z),n(d),n(ee),n(w),n(te),n(ne),n(_),n(ae),n(T),n(ie),n($),n(se),n(y),n(le),n(x),n(re),n(oe),n(C),n(ge),n(H),n(ue),n(L),n(me),n(P),n(ce),n(I),n(pe),n(G),n(fe),n(S),n(he),n(ve),n(E),n(de),n(R),n(we),n(U)),n(u),W(m,e),W(f,e),W(b,e),W(M,e),W(k,e)}}}const Ve='{"title":"The SnowballTarget Environment","local":"the-snowballtarget-environment","sections":[{"title":"The agent’s Goal","local":"the-agents-goal","sections":[],"depth":2},{"title":"The reward function and the reward engineering problem","local":"the-reward-function-and-the-reward-engineering-problem","sections":[],"depth":2},{"title":"The observation space","local":"the-observation-space","sections":[],"depth":2},{"title":"The action space","local":"the-action-space","sections":[],"depth":2}],"depth":1}';function Xe(_e){return We(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class tt extends Oe{constructor(u){super(),Ke(this,u,Xe,Qe,Be,{})}}export{tt as component};
