import{s as vt,f as Ue,n as wt,o as yt}from"../chunks/scheduler.37c15a92.js";import{S as bt,i as $t,g as r,s as n,r as p,m as xt,A as Ct,h as s,f as a,c as l,j as dt,u,x as o,n as _t,k as m,y as Lt,a as i,v as h,d as c,t as g,w as d}from"../chunks/index.7cb9c9b8.js";import{H as v}from"../chunks/Heading.d3928e2a.js";function Mt(ze){let f,ae,ee,ie,w,ne,y,Fe="Here we provide a list of interesting environments you can try to train your agents on:",le,b,re,$,Oe,se,x,We="DIAMBRA Arena is a software package featuring a collection of high-quality environments for Reinforcement Learning research and experimentation. It provides a standard interface to popular arcade emulated video games, offering a Python API fully compliant with OpenAI Gym/Gymnasium format, that makes its adoption smooth and straightforward.",oe,C,Ke='It supports all major Operating Systems (Linux, Windows and MacOS) and can be easily installed via <a href="https://pypi.org/project/diambra-arena/" rel="nofollow">Python PIP</a>. It is completely free to use, the user only needs to register on the <a href="https://diambra.ai/register/" rel="nofollow">official website</a>.',me,_,Qe='In addition, its <a href="https://github.com/diambra/" rel="nofollow">GitHub repository</a> provides a collection of examples covering main use cases of interest that can be run in just a few steps.',fe,L,pe,M,Ye="All environments are episodic Reinforcement Learning tasks, with discrete actions (gamepad buttons) and observations composed by screen pixels plus additional numerical data (RAM values like characters health bars or characters stage side).",ue,P,Je="They all support both single player (1P) as well as two players (2P) mode, making them the perfect resource to explore Standard RL, Competitive Multi-Agent, Competitive Human-Agent, Self-Play, Imitation Learning and Human-in-the-Loop.",he,T,Ne='<a href="https://docs.diambra.ai/envs/games/" rel="nofollow">Interfaced games</a> have been selected among the most popular fighting retro-games. While sharing the same fundamental mechanics, they provide different challenges, with specific features such as different type and number of characters, how to perform combos, health bars recharging, etc.',ce,k,Ve='DIAMBRA Arena is built to maximize compatibility will all major Reinforcement Learning libraries. It natively provides interfaces with the two most important packages: <a href="https://stable-baselines3.readthedocs.io/en/master/" rel="nofollow">Stable Baselines 3</a> and <a href="https://docs.ray.io/en/latest/rllib/index.html" rel="nofollow">Ray RLlib</a>, while Stable Baselines is also available but deprecated. Their usage is illustrated in the <a href="https://docs.diambra.ai/" rel="nofollow">official documentation</a> and in the <a href="https://github.com/diambra/agents" rel="nofollow">DIAMBRA Agents examples repository</a>. It can easily be interfaced with any other package in a similar way.',ge,A,de,I,Xe="DIAMBRA also provides a competition platform fully integrated with the Hugging Face Hub, on which you can submit your trained agents and compete with other coders around the globe in epic video games tournaments!",ve,H,Ze="It features a public leaderboard where users are ranked by the best score achieved by their agents in our different environments.",we,R,et="It also offers the possibility to unlock cool achievements depending on the performances of your agent.",ye,S,tt='Submitted agents are evaluated and their episodes are streamed on <a href="https://www.twitch.tv/diambra_ai" rel="nofollow">DIAMBRA Twitch channel</a>.',be,D,$e,q,at="To start using this environment, check these resources:",xe,j,it='<li><a href="https://docs.diambra.ai/" rel="nofollow">Official Docs</a></li> <li><a href="https://diambra.ai" rel="nofollow">Competition Platform</a></li> <li><a href="https://github.com/diambra/" rel="nofollow">GitHub</a></li> <li><a href="https://diambra.ai/discord" rel="nofollow">Discord</a></li>',Ce,G,_e,B,nt,Le,E,lt=`MineRL is a Python library that provides a Gym interface for interacting with the video game Minecraft, accompanied by datasets of human gameplay.
Every year there are challenges with this library. Check the <a href="https://minerl.io/" rel="nofollow">website</a>`,Me,U,rt="To start using this environment, check these resources:",Pe,z,st='<li><a href="https://www.youtube.com/watch?v=z6PTrGifupU" rel="nofollow">What is MineRL?</a></li> <li><a href="https://www.youtube.com/watch?v=8yIrWcyWGek" rel="nofollow">First steps in MineRL</a></li> <li><a href="https://minerl.readthedocs.io/en/latest/" rel="nofollow">MineRL documentation and tutorials</a></li>',Te,F,ke,O,ot,Ae,W,mt="To start using this environment, check these resources:",Ie,K,ft='<li><p><a href="https://docs.donkeycar.com/guide/deep_learning/simulator/" rel="nofollow">DonkeyCar Simulator documentation</a></p></li> <li><p><a href="https://www.youtube.com/watch?v=ngK33h00iBE" rel="nofollow">Learn to Drive Smoothly (Antonin Raffin’s tutorial) Part 1</a></p></li> <li><p><a href="https://www.youtube.com/watch?v=DUqssFvcSOY" rel="nofollow">Learn to Drive Smoothly (Antonin Raffin’s tutorial) Part 2</a></p></li> <li><p><a href="https://www.youtube.com/watch?v=v8j2bpcE4Rg" rel="nofollow">Learn to Drive Smoothly (Antonin Raffin’s tutorial) Part 3</a></p></li> <li><p>Pretrained agents:</p> <ul><li><a href="https://huggingface.co/araffin/tqc-donkey-mountain-track-v0" rel="nofollow">https://huggingface.co/araffin/tqc-donkey-mountain-track-v0</a></li> <li><a href="https://huggingface.co/araffin/tqc-donkey-avc-sparkfun-v0" rel="nofollow">https://huggingface.co/araffin/tqc-donkey-avc-sparkfun-v0</a></li> <li><a href="https://huggingface.co/araffin/tqc-donkey-minimonaco-track-v0" rel="nofollow">https://huggingface.co/araffin/tqc-donkey-minimonaco-track-v0</a></li></ul></li>',He,Q,Re,Y,pt,Se,J,ut='Starcraft II is a famous <em>real-time strategy game</em>. DeepMind has used this game for their Deep Reinforcement Learning research with <a href="https://www.deepmind.com/blog/alphastar-mastering-the-real-time-strategy-game-starcraft-ii" rel="nofollow">Alphastar</a>',De,N,ht="To start using this environment, check these resources:",qe,V,ct='<li><a href="http://starcraftgym.com/" rel="nofollow">Starcraft gym</a></li> <li><a href="https://www.youtube.com/watch?v=q59wap1ELQ4" rel="nofollow">A. I. Learns to Play Starcraft 2 (Reinforcement Learning) tutorial</a></li>',je,X,Ge,Z,gt='This section was written by <a href="https://twitter.com/ThomasSimonini">Thomas Simonini</a>',Be,te,Ee;return w=new v({props:{title:"Interesting Environments to try",local:"interesting-environments-to-try",headingTag:"h1"}}),b=new v({props:{title:"DIAMBRA Arena",local:"diambra-arena",headingTag:"h2"}}),L=new v({props:{title:"Main Features",local:"main-features",headingTag:"h4"}}),A=new v({props:{title:"Competition Platform",local:"competition-platform",headingTag:"h3"}}),D=new v({props:{title:"References",local:"references",headingTag:"h4"}}),G=new v({props:{title:"MineRL",local:"minerl",headingTag:"h2"}}),F=new v({props:{title:"DonkeyCar Simulator",local:"donkeycar-simulator",headingTag:"h2"}}),Q=new v({props:{title:"Starcraft II",local:"starcraft-ii",headingTag:"h2"}}),X=new v({props:{title:"Author",local:"author",headingTag:"h2"}}),{c(){f=r("meta"),ae=n(),ee=r("p"),ie=n(),p(w.$$.fragment),ne=n(),y=r("p"),y.textContent=Fe,le=n(),p(b.$$.fragment),re=n(),$=r("img"),se=n(),x=r("p"),x.textContent=We,oe=n(),C=r("p"),C.innerHTML=Ke,me=n(),_=r("p"),_.innerHTML=Qe,fe=n(),p(L.$$.fragment),pe=n(),M=r("p"),M.textContent=Ye,ue=n(),P=r("p"),P.textContent=Je,he=n(),T=r("p"),T.innerHTML=Ne,ce=n(),k=r("p"),k.innerHTML=Ve,ge=n(),p(A.$$.fragment),de=n(),I=r("p"),I.textContent=Xe,ve=n(),H=r("p"),H.textContent=Ze,we=n(),R=r("p"),R.textContent=et,ye=n(),S=r("p"),S.innerHTML=tt,be=n(),p(D.$$.fragment),$e=n(),q=r("p"),q.textContent=at,xe=n(),j=r("ul"),j.innerHTML=it,Ce=n(),p(G.$$.fragment),_e=n(),B=r("img"),Le=n(),E=r("p"),E.innerHTML=lt,Me=n(),U=r("p"),U.textContent=rt,Pe=n(),z=r("ul"),z.innerHTML=st,Te=n(),p(F.$$.fragment),ke=n(),O=r("img"),Ae=xt(`
Donkey is a Self Driving Car Platform for hobby remote control cars.
This simulator version is built on the Unity game platform. It uses their internal physics and graphics and connects to a donkey Python process to use our trained model to control the simulated Donkey (car).
`),W=r("p"),W.textContent=mt,Ie=n(),K=r("ul"),K.innerHTML=ft,He=n(),p(Q.$$.fragment),Re=n(),Y=r("img"),Se=n(),J=r("p"),J.innerHTML=ut,De=n(),N=r("p"),N.textContent=ht,qe=n(),V=r("ul"),V.innerHTML=ct,je=n(),p(X.$$.fragment),Ge=n(),Z=r("p"),Z.innerHTML=gt,Be=n(),te=r("p"),this.h()},l(e){const t=Ct("svelte-u9bgzb",document.head);f=s(t,"META",{name:!0,content:!0}),t.forEach(a),ae=l(e),ee=s(e,"P",{}),dt(ee).forEach(a),ie=l(e),u(w.$$.fragment,e),ne=l(e),y=s(e,"P",{"data-svelte-h":!0}),o(y)!=="svelte-1sc0z4o"&&(y.textContent=Fe),le=l(e),u(b.$$.fragment,e),re=l(e),$=s(e,"IMG",{src:!0,alt:!0}),se=l(e),x=s(e,"P",{"data-svelte-h":!0}),o(x)!=="svelte-1xk88eg"&&(x.textContent=We),oe=l(e),C=s(e,"P",{"data-svelte-h":!0}),o(C)!=="svelte-1gbedw7"&&(C.innerHTML=Ke),me=l(e),_=s(e,"P",{"data-svelte-h":!0}),o(_)!=="svelte-e4uji4"&&(_.innerHTML=Qe),fe=l(e),u(L.$$.fragment,e),pe=l(e),M=s(e,"P",{"data-svelte-h":!0}),o(M)!=="svelte-1zkqfu"&&(M.textContent=Ye),ue=l(e),P=s(e,"P",{"data-svelte-h":!0}),o(P)!=="svelte-1klwvp4"&&(P.textContent=Je),he=l(e),T=s(e,"P",{"data-svelte-h":!0}),o(T)!=="svelte-199a7jm"&&(T.innerHTML=Ne),ce=l(e),k=s(e,"P",{"data-svelte-h":!0}),o(k)!=="svelte-1d4w6sb"&&(k.innerHTML=Ve),ge=l(e),u(A.$$.fragment,e),de=l(e),I=s(e,"P",{"data-svelte-h":!0}),o(I)!=="svelte-w8r04o"&&(I.textContent=Xe),ve=l(e),H=s(e,"P",{"data-svelte-h":!0}),o(H)!=="svelte-9cd1v"&&(H.textContent=Ze),we=l(e),R=s(e,"P",{"data-svelte-h":!0}),o(R)!=="svelte-14cvuqx"&&(R.textContent=et),ye=l(e),S=s(e,"P",{"data-svelte-h":!0}),o(S)!=="svelte-1fe7qoz"&&(S.innerHTML=tt),be=l(e),u(D.$$.fragment,e),$e=l(e),q=s(e,"P",{"data-svelte-h":!0}),o(q)!=="svelte-nbb3hy"&&(q.textContent=at),xe=l(e),j=s(e,"UL",{"data-svelte-h":!0}),o(j)!=="svelte-td9lwm"&&(j.innerHTML=it),Ce=l(e),u(G.$$.fragment,e),_e=l(e),B=s(e,"IMG",{src:!0,alt:!0}),Le=l(e),E=s(e,"P",{"data-svelte-h":!0}),o(E)!=="svelte-11lnyw2"&&(E.innerHTML=lt),Me=l(e),U=s(e,"P",{"data-svelte-h":!0}),o(U)!=="svelte-nbb3hy"&&(U.textContent=rt),Pe=l(e),z=s(e,"UL",{"data-svelte-h":!0}),o(z)!=="svelte-108l0bw"&&(z.innerHTML=st),Te=l(e),u(F.$$.fragment,e),ke=l(e),O=s(e,"IMG",{src:!0,alt:!0}),Ae=_t(e,`
Donkey is a Self Driving Car Platform for hobby remote control cars.
This simulator version is built on the Unity game platform. It uses their internal physics and graphics and connects to a donkey Python process to use our trained model to control the simulated Donkey (car).
`),W=s(e,"P",{"data-svelte-h":!0}),o(W)!=="svelte-nbb3hy"&&(W.textContent=mt),Ie=l(e),K=s(e,"UL",{"data-svelte-h":!0}),o(K)!=="svelte-1wy7c3v"&&(K.innerHTML=ft),He=l(e),u(Q.$$.fragment,e),Re=l(e),Y=s(e,"IMG",{src:!0,alt:!0}),Se=l(e),J=s(e,"P",{"data-svelte-h":!0}),o(J)!=="svelte-jtizgn"&&(J.innerHTML=ut),De=l(e),N=s(e,"P",{"data-svelte-h":!0}),o(N)!=="svelte-nbb3hy"&&(N.textContent=ht),qe=l(e),V=s(e,"UL",{"data-svelte-h":!0}),o(V)!=="svelte-1jl391k"&&(V.innerHTML=ct),je=l(e),u(X.$$.fragment,e),Ge=l(e),Z=s(e,"P",{"data-svelte-h":!0}),o(Z)!=="svelte-at23v5"&&(Z.innerHTML=gt),Be=l(e),te=s(e,"P",{}),dt(te).forEach(a),this.h()},h(){m(f,"name","hf:doc:metadata"),m(f,"content",Pt),Ue($.src,Oe="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit12/diambraarena.png")||m($,"src",Oe),m($,"alt","diambraArena"),Ue(B.src,nt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit12/minerl.jpg")||m(B,"src",nt),m(B,"alt","MineRL"),Ue(O.src,ot="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit12/donkeycar.jpg")||m(O,"src",ot),m(O,"alt","Donkey Car"),Ue(Y.src,pt="https://huggingface.co/datasets/huggingface-deep-rl-course/course-images/resolve/main/en/unit12/alphastar.jpg")||m(Y,"src",pt),m(Y,"alt","Alphastar")},m(e,t){Lt(document.head,f),i(e,ae,t),i(e,ee,t),i(e,ie,t),h(w,e,t),i(e,ne,t),i(e,y,t),i(e,le,t),h(b,e,t),i(e,re,t),i(e,$,t),i(e,se,t),i(e,x,t),i(e,oe,t),i(e,C,t),i(e,me,t),i(e,_,t),i(e,fe,t),h(L,e,t),i(e,pe,t),i(e,M,t),i(e,ue,t),i(e,P,t),i(e,he,t),i(e,T,t),i(e,ce,t),i(e,k,t),i(e,ge,t),h(A,e,t),i(e,de,t),i(e,I,t),i(e,ve,t),i(e,H,t),i(e,we,t),i(e,R,t),i(e,ye,t),i(e,S,t),i(e,be,t),h(D,e,t),i(e,$e,t),i(e,q,t),i(e,xe,t),i(e,j,t),i(e,Ce,t),h(G,e,t),i(e,_e,t),i(e,B,t),i(e,Le,t),i(e,E,t),i(e,Me,t),i(e,U,t),i(e,Pe,t),i(e,z,t),i(e,Te,t),h(F,e,t),i(e,ke,t),i(e,O,t),i(e,Ae,t),i(e,W,t),i(e,Ie,t),i(e,K,t),i(e,He,t),h(Q,e,t),i(e,Re,t),i(e,Y,t),i(e,Se,t),i(e,J,t),i(e,De,t),i(e,N,t),i(e,qe,t),i(e,V,t),i(e,je,t),h(X,e,t),i(e,Ge,t),i(e,Z,t),i(e,Be,t),i(e,te,t),Ee=!0},p:wt,i(e){Ee||(c(w.$$.fragment,e),c(b.$$.fragment,e),c(L.$$.fragment,e),c(A.$$.fragment,e),c(D.$$.fragment,e),c(G.$$.fragment,e),c(F.$$.fragment,e),c(Q.$$.fragment,e),c(X.$$.fragment,e),Ee=!0)},o(e){g(w.$$.fragment,e),g(b.$$.fragment,e),g(L.$$.fragment,e),g(A.$$.fragment,e),g(D.$$.fragment,e),g(G.$$.fragment,e),g(F.$$.fragment,e),g(Q.$$.fragment,e),g(X.$$.fragment,e),Ee=!1},d(e){e&&(a(ae),a(ee),a(ie),a(ne),a(y),a(le),a(re),a($),a(se),a(x),a(oe),a(C),a(me),a(_),a(fe),a(pe),a(M),a(ue),a(P),a(he),a(T),a(ce),a(k),a(ge),a(de),a(I),a(ve),a(H),a(we),a(R),a(ye),a(S),a(be),a($e),a(q),a(xe),a(j),a(Ce),a(_e),a(B),a(Le),a(E),a(Me),a(U),a(Pe),a(z),a(Te),a(ke),a(O),a(Ae),a(W),a(Ie),a(K),a(He),a(Re),a(Y),a(Se),a(J),a(De),a(N),a(qe),a(V),a(je),a(Ge),a(Z),a(Be),a(te)),a(f),d(w,e),d(b,e),d(L,e),d(A,e),d(D,e),d(G,e),d(F,e),d(Q,e),d(X,e)}}}const Pt='{"title":"Interesting Environments to try","local":"interesting-environments-to-try","sections":[{"title":"DIAMBRA Arena","local":"diambra-arena","sections":[{"title":"Main Features","local":"main-features","sections":[],"depth":4},{"title":"Competition Platform","local":"competition-platform","sections":[{"title":"References","local":"references","sections":[],"depth":4}],"depth":3}],"depth":2},{"title":"MineRL","local":"minerl","sections":[],"depth":2},{"title":"DonkeyCar Simulator","local":"donkeycar-simulator","sections":[],"depth":2},{"title":"Starcraft II","local":"starcraft-ii","sections":[],"depth":2},{"title":"Author","local":"author","sections":[],"depth":2}],"depth":1}';function Tt(ze){return yt(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Ht extends bt{constructor(f){super(),$t(this,f,Tt,Mt,vt,{})}}export{Ht as component};
